#include <3694.h>
#include <stdio.h>

// ܂ł̋LqƂ̂x̌݊ۂ߂̃}N
#define rs_init     SCI3_INIT
#define rs_rx_buff  SCI3_IN_DATA_CHECK
#define rs_tx_buff  SCI3_OUT_DATA_CHECK
#define rs_rx_purge SCI3_IN_DATA_CLEAR
#define rs_tx_purge SCI3_OUT_DATA_CLEAR
#define rs_putc     SCI3_OUT_DATA
#define rs_puts     SCI3_OUT_STRING
#define rs_putsb    SCI3_OUT_STRINGB
#define rs_getc     SCI3_IN_DATA
#define rs_gets     SCI3_IN_STRING
#define rs_printf   SCI3_PRINTF

#define IDLE_LOOP     1000
#define TX_END_LOOP   1000
#define BUSBUSY_LOOP  1000

#define EX1_SEL		0x02					// extra i2c
#define RTC_SEL		0x01					// real time clock

// I/Os̒`
#define SEG7        IO.PDR5.BYTE

void init();
void twait(long time);
void int_timera(void);

char txb[10], rxb[10], buf[15];           // RS-232C ʐMpO[oϐ
unsigned char onoff;     /* ON,OFFp */

// |[gCjVCY
void I2C_Init(void){
 IO.PDR5.BIT.B6 = 0; //@P56,P57I2Cp̃oXC
 IO.PDR5.BIT.B7 = 0; //@P56,P57̃f[^0ɂĂ
 IO.PCR5 = IO.PCR5 & 0x3F; //@I2CEEPROMgꍇ P56,P57͂ɐݒ肵Ă
}

unsigned char I2C_ReadByte( unsigned short adrs ,unsigned char slave_adrs) {
    unsigned char data;

    TEEPROM eep = {ep256k, slave_adrs, adrs};
    if(slave_adrs == RTC_SEL){
        eep.MemSize = ep2k;
    }
    EEPROM_ByteRead (&eep, (_BYTE *)&data);

    return(data);
}

unsigned char I2C_WriteByte( unsigned short adrs , unsigned char wr_data ,unsigned char slave_adrs) {

    TEEPROM eep = {ep256k, slave_adrs, adrs};
    if(slave_adrs == RTC_SEL){
        eep.MemSize = ep2k;
    }
//    eep.MAddr = adrs;

    EEPROM_ByteWrite (&eep, wr_data);
    return(0);
}

int RTC_GetSeconds(void) {
  unsigned char dat;

  dat = I2C_ReadByte( 0x02,RTC_SEL );
  return ((dat >> 4) & 0x07) * 10 + (dat & 0x0f);
}

int RTC_GetMinutes(void) {
  unsigned char dat;

  dat = I2C_ReadByte( 0x03,RTC_SEL );
  return ((dat >> 4) & 0x07) * 10 + (dat & 0x0f);
}

int RTC_GetHours(void) {
  unsigned char dat;

  dat = I2C_ReadByte( 0x04,RTC_SEL );
  return ((dat >> 4) & 0x03) * 10 + (dat & 0x0f);
}

int RTC_GetDays(void) {
  unsigned char dat;

  dat = I2C_ReadByte( 0x05,RTC_SEL );
  return ((dat >> 4) & 0x03) * 10 + (dat & 0x0f);
}

int RTC_GetWeekends(void) {
  unsigned char dat;

  dat = I2C_ReadByte( 0x06,RTC_SEL );
  return(dat & 0x07);
}

int RTC_GetMonths(void) {
  unsigned char dat;

  dat = I2C_ReadByte( 0x07,RTC_SEL );
  return ((dat >> 4) & 0x01) * 10 + (dat & 0x0f);
}

int RTC_GetYears(void) {
  unsigned char dat;

  dat = I2C_ReadByte( 0x08,RTC_SEL );
  return ((dat >> 4) & 0x0f) * 10 + (dat & 0x0f);
}

void RTC_SetSeconds(int dat) {
  I2C_WriteByte( 0x02 , (((dat / 10 ) << 4) + (dat % 10)) & 0x7f , RTC_SEL );
}

void RTC_SetMinutes(int dat) {
  I2C_WriteByte( 0x03 , (((dat / 10 ) << 4) + (dat % 10)) & 0x7f , RTC_SEL );
}

void RTC_SetHours(int dat) {
  I2C_WriteByte( 0x04 , (((dat / 10 ) << 4) + (dat % 10)) & 0x3f , RTC_SEL );
}

void RTC_SetDays(int dat) {
  I2C_WriteByte( 0x05 , (((dat / 10 ) << 4) + (dat % 10)) & 0x3f , RTC_SEL );
}

void RTC_SetWeekends(int dat) {
  I2C_WriteByte( 0x06 , dat & 0x07 , RTC_SEL );
}

void RTC_SetMonths(int dat) {
  I2C_WriteByte( 0x07 , (((dat / 10 ) << 4) + (dat % 10)) & 0x7f , RTC_SEL );
}

void RTC_SetYears(int dat) {
  I2C_WriteByte( 0x08 , ((dat / 10 ) << 4) + (dat % 10) , RTC_SEL );
}

void diag_num(int mode,int num)
{
  // 7LED \p֐
  // mode 0:HH 1:MM
  
  char n0,n1;

  n1 = (int)(num/10);
  n0 = num - n1*10;
        
  if(mode == 1)
  {
      IO.PDR1.BIT.B0 = 1;
      IO.PDR1.BIT.B1 = 0;
      IO.PDR5.BYTE = 0xF0 | (0x0F & n1);
      twait(5000);

      IO.PDR1.BIT.B0 = 0;
      IO.PDR1.BIT.B1 = 1;
      IO.PDR5.BYTE = 0xF0 | (0x0F & n0);
      twait(3000);
  }
  if(mode == 0)
  {
      IO.PDR1.BIT.B0 = 1;
      IO.PDR1.BIT.B1 = 1;
      IO.PDR5.BYTE = 0x10 | (0x0F & n1);
      twait(3000);
      
      IO.PDR1.BIT.B0 = 1;
      IO.PDR1.BIT.B1 = 1;
      IO.PDR5.BYTE = 0x20 | (0x0F & n0);
      twait(3000);
  } 
}

void exec_relay(char num)
{
      switch(num)
      {
        case 1: IO.PDR8.BIT.B0 = 1; break;
        case 2: IO.PDR8.BIT.B1 = 1; break;
        case 3: IO.PDR8.BIT.B2 = 1; break;
        case 4: IO.PDR8.BIT.B3 = 1; break;
        
        case 5: IO.PDR8.BIT.B0 = 0; break;
        case 6: IO.PDR8.BIT.B1 = 0; break;
        case 7: IO.PDR8.BIT.B2 = 0; break;
        case 8: IO.PDR8.BIT.B3 = 0; break;
      };
}

void int_irq1(void)
{ 
  DI;
  IRR1.BIT.IRRI1=0;
  IENR1.BIT.IEN1=0;
  IENR1.BIT.IEN1=1; /* IRQ1݋ */
  
  IO.PDR8.BIT.B7 =0;
  EI;
}

int main()
{
  int HH,MM,SS;
  char c;
   
  DI;                                     // 荞ݕs
  init();                                 // H8/3664F 
  I2C_Init();
  EI;                                     // 荞݋
  
  do {
      HH = RTC_GetHours();
      MM = RTC_GetMinutes();
      SS = RTC_GetSeconds();
      
      diag_num(1,MM);
      diag_num(0,SS);

     // c = rs_getc();
     // exec_relay(c);
      
  }while(1);
  
  return 0;
}


void init()
{
  // H8/3664F 
  IO.PMR1.BYTE=0x00;                                            // S0ɃZbgA|[ggpɐݒ@0000 0000
  IO.PCR1  =0x03;                                               // SĂPɃZbgAo͂ɐݒ@1111@1111 
                                                                // PCRڼ޽́@IO.PCR1.BYTE@LqłȂI
  IO.PCR8 = 0xFF;                                               // LEDp|[g̐ݒ S1ZbgAo͂ɐݒ 
  IO.PCR5 = 0x3F;                                               // LEDp|[g̐ݒ S1ZbgAo͂ɐݒ 
    
  //SCI3.SCR3.BYTE = 0x30;   // 
  //SCI3.SCR3.BIT.TE = 1;   // M
  //SCI3.SCR3.BIT.RE = 1;   // M
  //SCI3.SSR.BYTE  &= 0x80;
  //SCI3.SMR.BYTE   = 0x00;
  
  SCI3_INIT(br19200, txb, sizeof(txb), rxb, sizeof(rxb));       // RS-232CʐM̏;
  
  //-----------------------
  // ^C}Vݒ (ŏ\1msEFCgp)
  //-----------------------
  TV.TCRV0.BIT.CCLR = 1;      // RyA}b`ATCNVNA
  TV.TCRV0.BIT.CKS  = 0;      // ~
  TV.TCRV1.BIT.ICKS = 1;      // LCKS=3ƕp /128=156.25kHz
  TV.TCSRV.BIT.CMFA = 0;      // tONA
  TV.TCNTV          = 0;      // ^C}JE^NA
  TV.TCORA          = 156-1;  // ^CRX^gWX^Aݒ 156.25kHz/1251ms

  //-----------------------
  // ^C}Aݒ 
  //-----------------------
  TA.TMA.BYTE=0x18;       /* I[o[t[1b */
  IRR1.BIT.IRRTA=0;       /* ^C}[`݃tÕZbg */
  IENR1.BIT.IENTA=1;      /* ^C}[`݂𗘗p\ɂ */
  
  //-----------------------
  // 荞ݐݒ 
  //-----------------------
  IO.PMR1.BIT.IRQ1=1; /* P15IRQ1ɃZbg */ 
  IEGR1.BIT.IEG1=0; /* IRQ1̗GbWo */
  IRR1.BIT.IRRI1=0; /* IRQ1ݗvtONA */ 
  IENR1.BIT.IEN1=1; /* IRQ1݋ */ 
}


void twait(long time)
{
  long i;
  
  for (i = 0; i < time; i++);
}

void int_timera(void)     /* ^C}[`݊֐ */
{
  IRR1.BIT.IRRTA=0;
  if(onoff==1){
    IO.PDR8.BIT.B7 =0;
    onoff=0;
  }else{
    IO.PDR8.BIT.B7=1;
    onoff=1;
  }
}
